"use strict";

import { showAlert } from "./alerts.js";
import Api from "./mqtt/api.js";

class Admin {

	constructor() {
		const adminPanel = document.querySelectorAll(".admin-panel");
		for (const panel of adminPanel)
			panel.classList.remove('invisible');
		this.setupListeners();
	}

	setupListeners() {
		const adminModals = document.querySelectorAll(".admin-modal");
		for (const modal of adminModals) {
			const cancelBtn = modal.querySelector('.btn-danger');
			cancelBtn.addEventListener('click', () => {
				// get all inputs and reset them
				const inputs = modal.querySelectorAll('input');
				for (const input of inputs)
					input.value = '';
				// get all select and reset them
				const selects = modal.querySelectorAll('select');
				for (const select of selects)
					select.value = 'unselected';
			});
		}
		this.scenariPanel();
		// TODO these other panels
		// this.antifurtoPanel();
		// this.luciPanel();
	}

	scenariPanel() {
		const submitBtn = document.getElementById("admin-scenari-submit");
		submitBtn.addEventListener('click', () => {
			const inApprendimento = document.getElementById("admin-in-apprendimento");
			const inScenari = document.getElementById("admin-in-scenari");
			const outScenari = document.getElementById("admin-out-scenari");
			const inApprendimentoValue = inApprendimento.value;
			const inScenariValue = inScenari.value;
			const outScenariValue = outScenari.value;
			if(inApprendimentoValue === inScenariValue){
				alert('Non puoi selezionare lo stesso ingresso per l\'apprendimento e per gli scenari.');
				return;
			}
			let json = {};
			inApprendimentoValue !== 'unselected' ? json["learn-trigger"] = inApprendimentoValue : null;
			inScenariValue !== 'unselected' ? json["attiva-scenari"] = inScenariValue : null;
			outScenariValue !== 'unselected' ? json["luce-antifurto"] = outScenariValue : null;
			if(Object.keys(json).length === 0){
				alert('Non hai selezionato nessuna porta.');
				return;
			}
			// send the json to the server
			Api.sendScenariConfiguration(json);
			// close the modal
			const closeBtn = submitBtn.closest('.modal').querySelector('.btn-danger');
			closeBtn.click();
		});
	}

}

export default Admin;